var dbtype
var dbhost
var dbport
var dbinstance
var dbuser
var dbpassword
var test
var testTip
var nextStep
var prevStep
var confirm
var confirmTip
var displayTip
var frontendErr
var backendErr
var backendErrText
var title
// var redishost
// var redisport
// var redisuser
var redispassword
var redismodel
var redisurl
var mqhostInput
var mqportInput
var mquserInput
var mqpasswordInput
var mcserviceurlInput
var cancel

var errTimer
var formContainer
var settingFromZK

$(function () {
  displayTip = $('#displayTip')
  formContainer = $('.formContainer')
  cancel = $('#cancel')
  frontendErr = $('#front-end-err')
  backendErr = $('#back-end-err')
  backendErrText = $('#back-end-err span')

  // initPage()
  getEchoSettings()
  getCloseTipsListener()
})

// 关闭提示
function getCloseTipsListener() {
  cancel.click(function () {
    clearTimeout(errTimer)
    backendErr.addClass('hidden')
  })
}

// 回显数据库配置
function getEchoSettings() {
  $.ajax({
    type: 'POST',
    url: 'auth/dbSetting.do',
    data: {dbecho: 1},
    beforeSend: function () {
      $('.mask').removeClass('hidden')
    },
    success: function (data) {
      if (data.errorcode) {
        var msg = data.description_cn || data.description
        if (msg == '苍穹平台不支持当前操作') {
          // 跳转至登录
          location.href = location.href.replace('dataBaseSetting.html', '')
        } else {
          // 已初始化则进行认证
          showAuthentication()
        }
        return
      }
      // 未初始化，开始配置流程
      showDatabaseInfo()
    },
    error: function (data) {
      if (data) showBackendErr(data.description_cn || data.description)
    },
    complete: function () {
      $('.mask').addClass('hidden')
    }
  })
}

// 认证
function getAuthListener() {
  confirm.click(function () {
    var password = dbpassword.val().trim()
    var isEmpty5 = isEmpty(password, '数据库密码')
    if (!isEmpty5.status) {
      showFrontendErr(dbpassword, isEmpty5.text)
      return false
    }
    $.ajax({
      type: 'POST',
      url: 'auth/dbSetting.do',
      data: {
        dbpassword: password,
        dbauth: 1
      },
      beforeSend: function () {
        $('.mask').removeClass('hidden')
      },
      success: function (data) {
        if (data.errorcode && data.errorcode !== 0) {
          testTip.html(data.description_cn || data.description)
          return false
        }
        // 回显已有数据
        settingFromZK = data
        showDatabaseInfo(settingFromZK)
      },
      error: function (data) {
        if (data) showBackendErr(data.description_cn || data.description)
      },
      complete: function () {
        $('.mask').addClass('hidden')
      }
    })
  })
}

// 测试连接
function getTestListener() {
  test.click(function () {
    if (!checkFormData()) return false
    var type = dbtype.val()
    var host = dbhost.val().trim()
    var port = dbport.val().trim()
    var instance = dbinstance.val().trim()
    var user = dbuser.val().trim()
    var password = dbpassword.val().trim()
    $.ajax({
      type: 'POST',
      url: 'auth/dbSetting.do',
      data: {
        dbtype: type,
        dbhost: host,
        dbport: port,
        dbinstance: instance,
        dbuser: user,
        dbpassword: password,
        dbcheck: 1,
        dbtest: 1
      },
      beforeSend: function () {
        $('.mask').removeClass('hidden')
      },
      success: function (data) {
        if (data.errorcode && parseInt(data.errorcode) !== 0) {
          showBackendErr(data.description_cn || data.description)
          return false
        }
        if (data.db) data = data.db
        testTip.html(!data.errorcode ? '连接成功' : data.description_cn || data.description)
      },
      complete: function () {
        $('.mask').addClass('hidden')
      }
    })
  })
}

// 下一步
function getNextStepListener() {
  nextStep.click(function () {
    if (!checkFormData()) return false
    var type = dbtype.val()
    var host = dbhost.val().trim()
    var port = dbport.val().trim()
    var instance = dbinstance.val().trim()
    var user = dbuser.val().trim()
    var password = dbpassword.val().trim()
    $.ajax({
      type: 'POST',
      url: 'auth/dbSetting.do',
      data: {
        dbtype: type,
        dbhost: host,
        dbport: port,
        dbinstance: instance,
        dbuser: user,
        dbpassword: password,
        dbcheck: 1
      },
      beforeSend: function () {
        $('.mask').removeClass('hidden')
      },
      success: function (data) {
        if (data.errorcode && parseInt(data.errorcode) !== 0) {
          showBackendErr(data.description_cn || data.description)
          return false
        }
        var db = data.db || {}
        if (db.errorcode == 1) {
          showBackendErr(data.description_cn || data.description)
          return false
        }
        // $('.databaseInfo').addClass('hidden')
        // $('.redisInfo').removeClass('hidden')
        // $('.mqInfo').removeClass('hidden')
        // $('.mcInfo').removeClass('hidden')
        // nextStep.parent().addClass('hidden')
        // confirm.parent().removeClass('hidden')
        showRedisMqInfo()
        //回显其他配置
        var zk = data.zk
        if (zk && Object.keys(zk).length > 0) {
          echoConfigs(zk, db)
          displayTip.html('当前显示ZK中的配置信息')
        } else {
          echoConfigs(db, {})
          displayTip.html('当前显示DB中的配置信息')
        }
        //mc.server.url
        var localmc = ('http://' + location.hostname + ':' + location.port + location.pathname).replace('/dataBaseSetting.html', '')
        var lastIndex = localmc.lastIndexOf('/')
        if (lastIndex == localmc.length - 1) localmc = localmc.substring(0, lastIndex)
        echo(mcserviceurlInput, localmc, db.mcserviceurl)
        if (!(localmc == db.mcserviceurl)) confirmTip.html('MC服务地址不一致，DB中配置为:[' + (db.mcserviceurl || '') + ']，请确认是否错连数据库！').css('color', 'red')
      },
      complete: function () {
        $('.mask').addClass('hidden')
      }
    })
  })
}

// 上一步
function getPrevStepListener() {
  prevStep.click(function () {
    // location.reload()
    showDatabaseInfo(settingFromZK)
  })
}

// 确认
function getConfirmListener() {
  confirm.click(function () {
    if (!checkFormData()) return false
    var type = dbtype.val()
    var host = dbhost.val().trim()
    var port = dbport.val().trim()
    var instance = dbinstance.val().trim()
    var user = dbuser.val().trim()
    var password = dbpassword.val().trim()
    // var rdhost = redishost.val().trim()
    // var rdport = redisport.val().trim()
    // var rduser = redisuser.val().trim()
    var rdpassword = redispassword.val().trim()
    var rdmodel = redismodel.val()
    var rdurl = redisurl.val()
    var mqhost = mqhostInput.val().trim()
    var mqport = mqportInput.val().trim()
    var mquser = mquserInput.val().trim()
    var mqpassword = mqpasswordInput.val().trim()
    var mqvhost = mqvhostInput.val().trim()
    var mcserviceurl = mcserviceurlInput.val().trim()
    $.ajax({
      type: 'POST',
      url: 'auth/dbSetting.do',
      data: {
        dbtype: type,
        dbhost: host,
        dbport: port,
        dbinstance: instance,
        dbuser: user,
        dbpassword: password,
        // redishost: rdhost,
        // redisport: rdport,
        // redisuser: rduser,
        redispassword: rdpassword,
        redismodel: rdmodel,
        redisurl: rdurl,
        mqhost: mqhost,
        mqport: mqport,
        mquser: mquser,
        mqpassword: mqpassword,
        mqvhost: mqvhost,
        mcserviceurl: mcserviceurl
      },
      beforeSend: function () {
        $('.mask').removeClass('hidden')
      },
      success: function (data) {
        if (data.errorcode && parseInt(data.errorcode) !== 0) {
          showBackendErr(data.description_cn || data.description)
          return false
        }
        window.location.href = data.RedirectURL
      },
      complete: function () {
        $('.mask').addClass('hidden')
      }
    })
  })
}

// 输入焦点效果
function getInputFocusListener() {
  $('.item .item-input').focus(function () {
    $(this).parent().addClass('active')
  }).blur(function () {
    $(this).parent().removeClass('active')
  })
}

function echoConfigs(dispConf, tipsConf) {
  echo(redismodel, dispConf.redismodel, tipsConf.redismodel)
  echo(redisurl, dispConf.redisurl, tipsConf.redisurl)
  echo(redispassword, dispConf.redispassword)
  echo(mqhostInput, dispConf.mqip, tipsConf.mqip)
  echo(mqportInput, dispConf.mqport, tipsConf.mqport)
  echo(mquserInput, dispConf.mquser, tipsConf.mquser)
  echo(mqvhostInput, dispConf.mqvhost, tipsConf.mqvhost)
}

function echo($input, dispVal, tipsVal) {
  $input.val(dispVal)
  if (tipsVal && tipsVal.trim() != dispVal) {
    var $span = $('<span class="icon-warning" title="该项与数据库配置不一致：[' + tipsVal + '](点击切换)">！</span>')
    $span.click(function () {
      $input.val(tipsVal)
    })
    $input.after($span)
  }
}

function checkFormData () {
  var host = dbhost.val().trim()
  var port = dbport.val().trim()
  var instance = dbinstance.val().trim()
  var user = dbuser.val().trim()
  var password = dbpassword.val().trim()
  var isEmpty1 = isEmpty(host, '数据库主机')
  var isEmpty2 = isEmpty(port, '数据库端口')
  var isEmpty3 = isEmpty(instance, '数据库实例')
  var isEmpty4 = isEmpty(user, '数据库用户')
  var isEmpty5 = isEmpty(password, '数据库密码')
  if (!isEmpty1.status) {
    showFrontendErr(dbhost, isEmpty1.text)
    return false
  }
  if (!isEmpty2.status) {
    showFrontendErr(dbport, isEmpty2.text)
    return false
  }
  if (!isEmpty3.status) {
    showFrontendErr(dbinstance, isEmpty3.text)
    return false
  }
  if (!isEmpty4.status) {
    showFrontendErr(dbuser, isEmpty4.text)
    return false
  }
  if (!isEmpty5.status) {
    showFrontendErr(dbpassword, isEmpty5.text)
    return false
  }
  if ($('.redisInfo').length > 0) {
    // var rdhost = redishost.val().trim()
    // var rdport = redisport.val().trim()
    var rdurl = redisurl.val()
    // var isEmpty6 = isEmpty(rdhost, 'redis主机')
    // var isEmpty7 = isEmpty(rdport, 'redis端口')
    var isEmpty6 = isEmpty(rdurl, 'redis地址')
    if (!isEmpty6.status) {
      showFrontendErr(redisurl, isEmpty6.text)
      return false
    }
    // if (!isEmpty7.status) {
    //   showFrontendErr(redisport, isEmpty7.text)
    //   return false
    // }
  }
  if ($('.mqInfo').length > 0) {
    var mqhost = mqhostInput.val().trim()
    var mqport = mqportInput.val().trim()
    var mquser = mquserInput.val().trim()
    var mqpassword = mqpasswordInput.val().trim()
    var isEmpty8 = isEmpty(mqhost, 'MQ主机')
    var isEmpty9 = isEmpty(mqport, 'MQ端口')
    var isEmpty10 = isEmpty(mquser, 'MQ用户')
    var isEmpty11 = isEmpty(mqpassword, 'MQ密码')
    if (!isEmpty8.status) {
      showFrontendErr(mqhostInput, isEmpty8.text)
      return false
    }
    if (!isEmpty9.status) {
      showFrontendErr(mqportInput, isEmpty9.text)
      return false
    }
    if (!isEmpty10.status) {
      showFrontendErr(mquserInput, isEmpty10.text)
      return false
    }
    if (!isEmpty11.status) {
      showFrontendErr(mqpasswordInput, isEmpty11.text)
      return false
    }
  }
  return true
}

// 提示前端校验不过的错误信息
function showFrontendErr (target, errText) {
  var parent = target.parent()
  parent.addClass('input-err')
  var parentOffset = parent.offset()
  var parentOuterHeight = parent.outerHeight()
  frontendErr.css({
    top: parentOffset.top + parentOuterHeight + 2 + 'px',
    left: parentOffset.left + 'px'
  })
  frontendErr.text(errText)
  frontendErr.removeClass('hidden')
  target.focus()
  target.keydown(function () {
    parent.removeClass('input-err')
    frontendErr.addClass('hidden')
    target.off('keydown')
  })
}

// 提示后端的报错信息
function showBackendErr (errText) {
  if (errText === undefined || errText.trim() === '') return
  backendErrText.text(errText)
  backendErr.removeClass('hidden')
  backendErr.css({
    // top: title.offset().top + title.outerHeight() + 3 + 'px',
    top: '100px',
    opacity: 1
  })
  clearTimeout(errTimer)
  errTimer = setTimeout(function () {
    backendErr.removeAttr('style')
    backendErr.addClass('hidden')
  }, 3000)
}

function isEmpty (value, textPrefix) {
  if (textPrefix === undefined) textPrefix = ''
  var commonText = '不能为空！'
  if (!value) {
    return { status: false, text: textPrefix + commonText }
  } else {
    return { status: true }
  }
}

// div迁入js防止F12篡改
function showAuthentication() {
  formContainer.removeClass('hidden').html($('<div class="content">' + 
    '<div class="authentication">' +
    '  <div class="title">请输入ZK现有数据库密码进行认证</div>' + 
    '  <div class="panel">' + 
    '    <div class="item">' + 
    // '      <label for="dbpassword" class="item-label">数据库密码：</label>' +
    '      <input id="dbpassword" class="item-input" type="password" autocomplete="off" placeholder="请输入数据库密码" spellcheck="false" />' + 
    '    </div>' + 
    '  </div>' + 
    '</div>' +
    '</div>' +
    '<div>' +
    '  <span id="testTip" class="test-tip"></span>' +
    '  <button type="button" id="confirm" class="btn-item auth">确定</button>' +
    '</div>'))
  testTip = $('#testTip')
  confirm = $('#confirm')
  dbpassword = $('#dbpassword').keydown(function (e) {
  	if (e.keyCode == 13) {
  		confirm.click()
  	}
  })
  getAuthListener()
}

function showDatabaseInfo(data) {
  displayTip.empty()
  formContainer.removeClass('hidden').html($('<div class="content">' + 
    '<div class="databaseInfo">' + 
    '  <div id="title" class="title">数据库信息</div>' + 
    '  <div class="panel">' + 
    '    <div class="item">' + 
    '      <label for="dbtype" class="item-label">类型：</label>' +
    '      <select id="dbtype" class="item-input" type="text" placeholder="数据库类型">' + 
    '        <option value="1">Mysql</option>' + 
    '        <option value="3">Oracle</option>' + 
    '        <!-- <option value="12">Gauss</option> -->' + 
    '      </select>' + 
    '    </div>' + 
    '    <div class="item">' + 
    '      <label for="dbhost" class="item-label">主机：</label>' +
    '      <input id="dbhost" class="item-input" type="text" autocomplete="off" placeholder="请输入数据库主机(例:127.0.0.1)" spellcheck="false" />' + 
    '    </div>' + 
    '    <div class="item">' + 
    '      <label for="dbport" class="item-label">端口：</label>' +
    '      <input id="dbport" class="item-input" type="text" autocomplete="off" placeholder="请输入数据库端口(例:3306)" spellcheck="false" />' + 
    '    </div>' + 
    '    <div class="item">' + 
    '      <label for="dbinstance" class="item-label">实例：</label>' +
    '      <input id="dbinstance" class="item-input" type="text" autocomplete="off" placeholder="请输入数据库实例" spellcheck="false" />' + 
    '    </div>' + 
    '    <div class="item">' +
    '      <label for="dbuser" class="item-label">用户：</label>' +
    '      <input id="dbuser" class="item-input" type="text" autocomplete="off" placeholder="请输入数据库用户名" spellcheck="false" />' + 
    '    </div>' + 
    '    <div class="item">' + 
    '      <label for="dbpassword" class="item-label">密码：</label>' +
    '      <input id="dbpassword" class="item-input" type="password" autocomplete="off" placeholder="请输入数据库密码" spellcheck="false" />' + 
    '    </div>' + 
    '  </div>' + 
    '</div>' +
    '</div>' + 
    '<div>' +
    '  <span id="testTip" class="test-tip"></span>' +
    '  <button type="button" id="test" class="btn-item">测试连接</button>' +
    '  <button type="button" id="nextStep" class="btn-item">下一步</button>' +
    '</div>'))
  dbtype = $('#dbtype')
  dbhost = $('#dbhost')
  dbport = $('#dbport')
  dbinstance = $('#dbinstance')
  dbuser = $('#dbuser')
  dbpassword = $('#dbpassword')
  test = $('#test')
  testTip = $('#testTip')
  nextStep = $('#nextStep')
  $('.databaseInfo input').on('input', function () {
    testTip.empty()
  })
  $('.databaseInfo select').change(function () {
    testTip.empty()
  })
  getTestListener()
  getNextStepListener()
  // 回显数据
  if (data) {
    if (data.dbtype && data.dbtype == 2) data.dbtype = 1
    $.each(Object.keys(data), function () {
      if ($('#' + this)) $('#' + this).val(data[this])
    })
  }
}

function showRedisMqInfo() {
  formContainer.removeClass('hidden').html($('<div class="content">' + 
    '<div class="redisInfo">' +
    '    <div class="title">Redis信息</div>' +
    '    <div class="panel">' +
    '        <!-- <div class="item">' +
    '          <input id="redishost" class="item-input" type="text" autocomplete="off" placeholder="redis主机" spellcheck="false" />' +
    '        </div> -->' +
    '        <!-- <div class="item">' +
    '          <input id="redisport" class="item-input" type="text" autocomplete="off" placeholder="redis端口" spellcheck="false" />' +
    '        </div> -->' +
    '        <!-- <div class="item">' +
    '          <input id="redisuser" class="item-input" type="text" autocomplete="off" placeholder="redis用户（选填）" spellcheck="false" />' +
    '        </div> -->' +
    '        <!-- <div class="item">' +
    '          <input id="redispassword" class="item-input" type="password" autocomplete="off" placeholder="redis密码（选填）" spellcheck="false" />' +
    '        </div> -->' +
    '        <div class="item">' +
    '          <label for="redismodel" class="item-label">模式：</label>' +
    '          <select id="redismodel" class="item-input" type="text" placeholder="单机">' +
    '            <option value="redis">单机</option>' +
    '            <option value="cluster">集群</option>' +
    '            <option value="sentinel">哨兵</option>' +
    '          </select>' +
    '        </div>' +
    '        <div class="item">' +
    '          <label for="redisurl" class="item-label">地址：</label>' +
    '          <input id="redisurl" class="item-input" type="text" autocomplete="off" placeholder="请输入Redis地址(例:127.0.0.1:6379)" spellcheck="false" />' +
    '        </div>' +
    '        <input id="redispassword" type="hidden" autocomplete="off"/>' +
    '    </div>' +
    '</div>' +
    '<div class="mcInfo">' +
    '    <div class="title">MC信息</div>' +
    '    <div class="panel">' +
    '        <div class="item">' +
    '          <label for="mcserviceurl" class="item-label">地址：</label>' +
    '          <input id="mcserviceurl" class="item-input" type="text" autocomplete="off" placeholder="请输入MC服务地址(例:http://127.0.0.1:8090/ierp/)" spellcheck="false" />' +
    '        </div>' +
    '    </div>' +
    '</div>' +
    '<div class="mqInfo">' +
    '    <div class="title">MQ信息</div>' +
    '    <div class="panel">' +
    '        <div class="item">' +
    '          <label for="mqhost" class="item-label">主机：</label>' +
    '          <input id="mqhost" class="item-input" type="text" autocomplete="off" placeholder="请输入MQ主机(例:127.0.0.1)" spellcheck="false" />' +
    '        </div>' +
    '        <div class="item">' +
    '          <label for="mqport" class="item-label">端口：</label>' +
    '          <input id="mqport" class="item-input" type="text" autocomplete="off" placeholder="请输入MQ端口(例:5672)" spellcheck="false" />' +
    '        </div>' +
    '        <div class="item">' +
    '          <label for="mquser" class="item-label">用户：</label>' +
    '          <input id="mquser" class="item-input" type="text" autocomplete="off" placeholder="请输入MQ用户" spellcheck="false" />' +
    '        </div>' +
    '        <div class="item">' +
    '          <label for="mqpassword" class="item-label">密码：</label>' +
    '          <input id="mqpassword" class="item-input" type="password" autocomplete="off" placeholder="请输入MQ密码" spellcheck="false" />' +
    '        </div>' +
    '        <div class="item">' +
    '          <label for="mqvhost" class="item-label">vhost：</label>' +
    '          <input id="mqvhost" class="item-input" type="mqvhost" autocomplete="off" placeholder="请输入MQ虚拟主机" spellcheck="false" />' +
    '        </div>' +
    '    </div>' +
    '</div>' + 
    '</div>' + 
    '<div>' +
    '    <span id="confirmTip" class="test-tip confirm-tip"></span>' +
    '    <button type="button" id="prevStep" class="btn-item">上一步</button>' +
    '    <button type="button" id="confirm" class="btn-item">确认</button>' +
    '</div>'))
  prevStep = $('#prevStep')
  confirm = $('#confirm')
  confirmTip = $('#confirmTip')
  title = $('.redisInfo .title')
  // redishost = $('#redishost')
  // redisport = $('#redisport')
  // redisuser = $('#redisuser')
  redispassword = $('#redispassword')
  redismodel = $('#redismodel')
  redisurl = $('#redisurl')
  mqhostInput = $('#mqhost')
  mqportInput = $('#mqport')
  mquserInput = $('#mquser')
  mqpasswordInput = $('#mqpassword')
  mqvhostInput = $('#mqvhost')
  mcserviceurlInput = $('#mcserviceurl')
  getPrevStepListener()
  getConfirmListener()
}