// require('expose-loader?$!jquery')
$(document).ready(function () {
  function getUrlParam (name) {
    var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)')
    var r = window.location.search.substr(1).match(reg)
    if (r != null) return unescape(r[2]); return null
  }
  var pathName = window.location.pathname
  var lastIndex = pathName.lastIndexOf('/')
  pathName = pathName.slice(0, lastIndex)
  // console.log(pathName)
  var number = getUrlParam('number')
  var updateId = getUrlParam('updateId')
  var envId = getUrlParam('envId')
  var processCode = getUrlParam('processCode')
  var trainLog = getUrlParam('trainLog')
  function postApi (url, data = {}) {
    return $.ajax({
      type: 'post',
      url: url,
      async: false,
      dataType: 'json',
      data: JSON.stringify(data),
      contentType: 'application/json;charset=UTF-8',
      success: function (res) {
        return res
      },
      error: function (res) {
        // console.log(res)
      }
    })
  }
  // 获取重建元数据信息
  function getRebuildDataResult (updateId) {
    let data = {
      updateId: updateId
    }
    let url = 'kapi/app/mc/getRebuildDataResultService'
    return postApi(url, data)
  }
  function getTimeNode (item) {
    if (item.startTime) {
      if (item.finishTime) {
        return ('<div class=time><span>' + formatTime(item.startTime) + '</span>-<span>' + formatTime(item.finishTime) + '</span></div>')
      }
      return '<div class=time><span>' + formatTime(item.startTime) + '</span></div>'
    } else {
      return '<div class=time />'
    }
  }
  function formatTime (time) {
    if (time) {
      let date = new Date(time)
      let year = date.getFullYear()
      let month = date.getMonth() + 1
      let day = date.getDate()
      let hour = date.getHours()
      let minute = date.getMinutes()
      let second = date.getSeconds()
      return year + '/' + month + '/' + day + ' ' + hour + ':' + minute + ':' + second
    } else {
      return ''
    }
  }
  // 获取数据中心升级信息
  function getDataCenterStatus (updateId, envId, number) {
    let data = {
      envId: envId,
      updateId: updateId,
      number: number
    }
    let url = 'kapi/app/mc/getDataCenterStatusService'
    return postApi(url, data)
  }
  // 获取单步日志
  function getEnvUpdateLogService (updateId, processCode) {
    let data = {
      updateId: updateId,
      processCode: processCode
    }
    let url = 'kapi/app/mc/getEnvUpdateLogService'
    return postApi(url, data)
  }
  // 获取升级步骤
  function getUpgradeStatus (updateId, envId, number) {
    let data = {
      updateId: updateId,
      envId: envId,
      number: number
    }
    let url = 'kapi/app/mc/GetUpgradeStatus'
    return postApi(url, data)
  }
  function clickaction (index, type) {
    let dom
    if (type === 'datacenter') {
      dom = document.getElementsByClassName('datecenterTr')[index]
    } else {
      dom = document.getElementsByClassName('rebuildTr')[index]
    }
    // let ptr = dom.parentNode
    let nexttr = dom.nextSibling
    let domFirstChild = dom.firstChild
    if (domFirstChild.innerHTML === '▼') {
      domFirstChild.innerHTML = '▲'
      nexttr.setAttribute('style', 'display:table-row')
      window.sessionStorage.setItem([type, index].join(''), true)
    } else {
      domFirstChild.innerHTML = '▼'
      nexttr.setAttribute('style', 'display:none')
      window.sessionStorage.removeItem([type, index].join(''))
    }
  }
  function transformStatus (status) {
    switch (status) {
      case '0' :
        return '失败'
      case '1' :
        return '成功'
      case '2' :
        return '升级中'
      case '3' :
        return '等待'
      case '4' : 
        return '就绪'
      case '5' :
        return '成功(有警告)'
      default :
        return status
    }
  }
  let datacenterLog = ''
  let anotherLog = ''
  let upgrade = ''
  let dataCenterList = []
  let rbDataCenterList = []
  // let liList = ''
  // let title = processCode === 'datacentersUpdate' ? '数据中心升级' : '元数据重建'
  function getDataCenterList (callback) {
    let dataTable = ''
    getDataCenterStatus(updateId, envId, number).then(resp => {
      if (resp.errorcode == 100) {
        upgrade = resp.data
      }
      if (upgrade && upgrade.length != 0) {
        dataCenterList = upgrade.map((item, index) => {
          return {
            id: item.dataCenterId,
            name: item.dataCenterName,
            dataCenterNumber: item.dataCenterNumber,
            status: item.status,
			elapsedTime: item.elapsedTime,
            tasks: item.tasks
          }
        })
      }
      // dataCenterList = [{ 'name': '数据中心升级', 'dataCenterNumber': 'aaa', 'status': '成功', 'tasks': [{ 'scriptName': 'h', 'status': '成功' }, { 'scriptName': 'hahaha', 'status': '成功' }] }, { 'name': 'aaa', 'dataCenterNumber': 'aaa', 'status': '成功', 'tasks': [{ 'scriptName': 'hahaha' }] }, { 'name': 'aaa', 'dataCenterNumber': 'aaa', 'status': '成功', 'tasks': [{ 'scriptName': 'hahaha' }] }]
      dataTable = callback(dataCenterList, '数据中心升级', 'datacentersUpdate')
    })
    return dataTable
  }
  function getRebuildDataCenterList (callback) {
    let rbDataTable = ''
    getRebuildDataResult(updateId).then(resp => {
      if (resp.errorcode == 100) {
        let data = resp && resp.data
        rbDataCenterList = (data || []).map(item => {
          return {
            id: item.dataCenterId,
            name: item.dataCenterName,
            dataCenterNumber: item.dataCenterNumber,
            status: item.status,
            tasks: item.detail
          }
        })
      }
      // rbDataCenterList = [{ 'name': '元数据重建', 'dataCenterNumber': 'aaa', 'status': '成功', 'tasks': [{ 'scriptName': 'h', 'status': '成功' }, { 'scriptName': 'hahaha', 'status': '成功' }] }, { 'name': 'aaa', 'dataCenterNumber': 'aaa', 'status': '成功', 'tasks': [{ 'scriptName': 'hahaha' }] }, { 'name': 'aaa', 'dataCenterNumber': 'aaa', 'status': '成功', 'tasks': [{ 'scriptName': 'hahaha' }] }]
      rbDataTable = callback(rbDataCenterList, '元数据重建', 'rebuildMetaData')
    })
    return rbDataTable
  }
  function getAnotherStepLists () {
    let anotherStepLists = []
    getUpgradeStatus(updateId, envId, number).then(resp => {
      if (resp.errorcode == 100) {
        let data = resp && resp.data
        let stepLists = data.info || []
        anotherStepLists = stepLists.filter(item => {
          return item.processCode != 'datacentersUpdate' && item.processCode != 'rebuildMetaData'
        })
      }
    })
    return anotherStepLists
  }
  function getAnotherStepLog () {
    let stepLists = getAnotherStepLists()
    let stepLog = ''
    stepLists.map(item => {
      getEnvUpdateLogService(updateId, item.processCode).then(resp => {
        stepLog += resp && resp.data.join('\n')
      })
    })
    anotherLog = stepLog
    return anotherLog
  }
  if (processCode === 'datacentersUpdate') {
    datacenterLog = getDataCenterList(createTable)
    // datacenterLog = createTable(dataCenterList, '数据中心升级')
  } else if (processCode === 'rebuildMetaData') {
    datacenterLog = getRebuildDataCenterList(createTable)
    // datacenterLog = createTable(rbDataCenterList, '元数据重建')
  } else if (trainLog) {
    // 地铁线日志
    getAnotherStepLog()
    var dom = document.getElementsByClassName('otherLogTitle')
    dom[0].style.display = 'block'
    datacenterLog += getDataCenterList(createTable)
    datacenterLog += getRebuildDataCenterList(createTable)
  }
  function convertDateFromString(dateString) { 
    if (dateString) return new Date(dateString.substring(0,19).replace(/-/g,'/'));
  }
  function covertTimeFromSecond(second) {
    var str = ''
    if (second) {
      second = Math.floor(second)
      var min = Math.floor(second / 60)
      // if (min > 0) {
        var hour = Math.floor(min / 60)
        // if (hour > 0) 
          str += hour + '时'
        str += min % 60 + '分'
      // }
      str += second % 60 + '秒'
    }
    return str
  }
  function createTable (centerList, title, processCode) {
    let datacenterLog = ''
    datacenterLog += '<table style="text-align:center; border-collapse:collapse">'
    datacenterLog += '<caption>' + title + '</caption>'
    datacenterLog += '<tr style="background:#FAFAFA"><td width="10%"></td>'
    datacenterLog += '<td width="25%" style="text-align:left">数据中心名称</td>'
    datacenterLog += '<td width="20%">编码</td>'
    datacenterLog += '<td width="10%">升级状态</td>'
    datacenterLog += '<td width="10%">升级耗时</td>'
    datacenterLog += '<td width="25%">查看详情</td>'
    datacenterLog += '</tr>'
    let className = processCode === 'datacentersUpdate' ? 'datecenterTr' : processCode === 'rebuildMetaData' ? 'rebuildTr' : ''
    let type = processCode === 'datacentersUpdate' ? 'datacenter' : 'rebuild'
    centerList.map((center, index) => {
      let isShow = window.sessionStorage.getItem([type, index].join(''))
      let displayType = isShow ? 'table-row' : 'none'
      let arrow = isShow ? '▲' : '▼'
      let displayStatus = center.status
	  // 处理总耗时
	  let dcElapsedTime = displayStatus
	  if (center.elapsedTime && center.elapsedTime > 0) dcElapsedTime = covertTimeFromSecond(center.elapsedTime)
      let fontColor = displayStatus === '成功' ? 'green' : displayStatus === '失败' ? 'red' : displayStatus === '成功(有警告)' ? 'yellow' : 'blue'
      let centerurl = '<a target="_blank" href=' + pathName + '/mcLogDetail.html?' + '&updateId=' + updateId + '&centerId=' + center.id + '&processCode=' + processCode + '>查看详情</a>'
      datacenterLog += '<tr class="' + className + '"><td>' + arrow + '</td>'
      datacenterLog += '<td style="text-align:left">' + center.name + '</td>'
      datacenterLog += '<td>' + center.dataCenterNumber + '</td>'
      datacenterLog += '<td class="' + fontColor + '">' + center.status + '</td>'
      datacenterLog += '<td>' + dcElapsedTime + '</td>'
      datacenterLog += '<td>' + centerurl + '</td>'
      datacenterLog += '</tr>'
      datacenterLog += '<tr style="display:' + displayType + '"><td colspan="6" style="padding: 0px"><table class="innerTable">'
      if (!center.tasks || center.tasks.length === 0) {
        datacenterLog += '<tr><td colspan="5" style="padding: 5px; letter-space:2px">当前数据中心无详细信息...</td></tr>'
      }
      (center.tasks || []).map(task => {
        let showName = task.scriptName || task.appNumber
        let displayStatus = transformStatus(task.status)
        let fontColor = displayStatus === '成功' ? 'green' : displayStatus === '失败' ? 'red' : displayStatus === '成功(有警告)' ? 'yellow' : 'blue'
        let linkurl = processCode === 'datacentersUpdate' ? '<a target="_blank" href=' + pathName + '/mcLogDetail.html?taskid=' + task.taskid + '>查看详情</a>' : '<a target="_blank" href=' + pathName + '/mcLogDetail.html?' + '&updateId=' + updateId + '&centerId=' + center.id + '&appNumber=' + task.appNumber + '>查看详情</a>'
        // 处理升级耗时
        let displayTime = transformStatus(task.status);
		if (task.elapsedTime && task.elapsedTime > 0) displayTime = covertTimeFromSecond(task.elapsedTime)
        datacenterLog += '<tr><td width="10%"></td>' +
          '<td width="25%" style="text-align:left; white-space: normal;">' + showName + '</td><td width="20%"></td>' +
          '<td width="10%" class="' + fontColor + '">' + transformStatus(task.status) + '</td><td width="10%">' + displayTime + '</td><td width="25%">' + linkurl + '</td></tr>'
      })
      datacenterLog += '</table></td></tr>'
    })
    datacenterLog += '</table>'
    return datacenterLog
  }

  var datacenterTrs = document.getElementsByClassName('datecenterTr')
  var rebuildTrs = document.getElementsByClassName('rebuildTr')
  var tagA = document.getElementsByTagName('a')
  setTimeout(function () {
    for (let i = 0; i < datacenterTrs.length; i++) {
      datacenterTrs[i].onclick = () => clickaction(i, 'datacenter')
    }
    for (let k = 0; k < rebuildTrs.length; k++) {
      rebuildTrs[k].onclick = () => clickaction(k, 'rebuild')
    }
    for (let j = 0; j < tagA.length; j++) {
      tagA[j].addEventListener('click', function (e) {
        e.stopPropagation()
      }, false)
    }
  }, 0)

  document.getElementById('upLog').innerHTML = datacenterLog
  document.getElementById('stepLogs').innerHTML = anotherLog
})
